--
-- JD7RSeries
-- Specialization class for JD7RSeries
-- @Authors of original scripts used: Manuel Leithner (SFM-Modding),Modelleicher (www.schwabenmodding.bplaced.net),Templaer, JoXXer, Knagsted, Mofa-Killer, Face, Heady, other do not remember!!
-- @author  Ago-Systemtech
-- 
-- @DATE  24/12/14 ADD FIX FOR USE JD 7R SERIES, FS15 Ago-Systemtech(alias Ago-Modding): https://www.facebook.com/ago.systemtech (Modhoster Team)
------ free for non commercial-usage -------------

JD7RSeries = {};
function JD7RSeries.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;
function JD7RSeries:load(xmlFile)
		
	self.FrizioneFrenoRotation = SpecializationUtil.callSpecializationsFunction("FrizioneFrenoRotation");
	
	self.updateFuelIndicators = SpecializationUtil.callSpecializationsFunction("updateFuelIndicators");
	self.ledriserva = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.ledriserva#index"));
	self.ledriservaActive = false;
	self.riserva = 60;
		
	--------------------Sound Inversore-------------------
	InversoreDirectionSoundFile = Utils.getFilename("Sound/gearShift.wav", self.baseDirectory);
	self.InversoreDirectionSoundId = createSample("InversoreDirectionSound");
    loadSample(self.InversoreDirectionSoundId, InversoreDirectionSoundFile, false);
    self.InversoreDirectionPlaying = false;
	
	self.isSelectable = true;
	-------------------------PEDALI-------------------------
	local PedaleGasNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.PedaleGas#index"));
    if PedaleGasNode ~= nil then
        self.PedaleGas = {};
        self.PedaleGas.node = PedaleGasNode;
		self.PedaleGas.maxSpeed = getXMLInt(xmlFile, "vehicle.PedaleGas#maxSpeed");
		local x1,y1,z1 = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.PedaleGas#minRot"));
		local x2,y2,z2 = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.PedaleGas#maxRot"));
		self.PedaleGas.rotMin = {math.rad(Utils.getNoNil(x1,0)),math.rad(Utils.getNoNil(y1,0)),math.rad(Utils.getNoNil(z1,0))};
		self.PedaleGas.rotMax = {math.rad(Utils.getNoNil(x2,0)),math.rad(Utils.getNoNil(y2,0)),math.rad(Utils.getNoNil(z2,0))};
    end;
	
	self.PedaleFrizione = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.PedaleFrizione#index"));
	self.PedaleFreno = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.PedaleFreno#index"));
	
	-------------------------- LEVE ----------------------
	-- self.levaindicatori = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.levaindicatori#index"));
	self.LevaHandbrake = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.LevaHandbrake#index"));
	 
	--------------------------LED-------------------------
		self.handbrakelight = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.handbrakelight#index"));
		self.olioicona = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.olioicona#index"));
		self.ledLampeggiante = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.ledLampeggiante#index"));
		self.LedStart = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.LedStart#index"));
		self.ledFrontwork = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.ledFrontwork#index"));
		self.ledRearwork = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.ledRearwork#index"));
		self.led4WDon = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Led4WDon#index"));
		self.led4WDoff = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Led4WDoff#index"));
		self.PTOLed = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.PTOLed#index"));
	
		self.frontled = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.frontled#index"));
		self.reverseled = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.reverseled#index"));

	----------------- GASOLIO INDICATORI----------
	self.fuelIndicatorsGroup = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fuelIndicators#index"));
	self.numFuelIndicators = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.fuelIndicators#count"), 0);
	self.fuelIndicators = {};
    for i=1, self.numFuelIndicators do
        local objname = string.format("vehicle.fuelIndicators.fuelIndicator" .. "%d", i);
		self.fuelIndicators[i] = {};
        self.fuelIndicators[i].rotNode = Utils.indexToObject(self.components, getXMLString(xmlFile, objname .. "#rotNode"));
		setVisibility(self.fuelIndicators[i].rotNode,true);
    end;
	--------------------PARAFANGHI------------------
	-- self.fender = {};
	-- self.fender.leftNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fender#leftIndex"));
	-- self.fender.rightNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fender#rightIndex"));
	-- self.fender.leftRotMax = getXMLInt(xmlFile, "vehicle.fender#leftRotMax");
	-- self.fender.rightRotMax = getXMLInt(xmlFile, "vehicle.fender#rightRotMax");

	-----------------SOUND RISERVA------------------
    fuelwarningSoundFile = Utils.getFilename("Sound/fuelwarning.wav", self.baseDirectory);
    self.fuelwarningSoundId = createSample("fuelwarningSound");
    loadSample(self.fuelwarningSoundId, fuelwarningSoundFile, false);
    self.fuelwarningPlaying = false;
	self.playedSound = false;
	

	
end;
function JD7RSeries:delete()

end;
function JD7RSeries:readStream(streamId, connection)
end;
function JD7RSeries:writeStream(streamId, connection)
end;
function JD7RSeries:readUpdateStream(streamId, timestamp, connection)
	if connection:getIsServer() then
		if streamReadBool(streamId) then
		end;
	end;
end;
function JD7RSeries:writeUpdateStream(streamId, connection, dirtyMask)
	if not connection:getIsServer() then
		if streamWriteBool(streamId, bitAND(dirtyMask, self.vehicleDirtyFlag) ~= 0) then
        end;
    end;
end;
function JD7RSeries:mouseEvent(posX, posY, isDown, isUp, button)
end;

function JD7RSeries:setFenderVisibility(isVisible)
	setVisibility(self.fenders.rear, isVisible);
end;
function JD7RSeries:keyEvent(unicode, sym, modifier, isDown)
	
end;

function JD7RSeries:FrizioneFrenoRotation(dt, acceleration)
	-- if self.PedaleFrizione ~= nil then
		-- local FrizioneActive = false;
		-- if acceleration > 0 then
			-- FrizioneActive = true;
		-- end;

		-- local FrizioneMax = {};
		-- FrizioneMax[1] = math.rad(-52);
		-- FrizioneMax[2] = math.rad(0);
		-- FrizioneMax[3] = math.rad(0);
		-- local FrizioneRotationTime = 200;

		-- local FrizioneMin = {};
		-- FrizioneMin[1] = math.rad(-30);
		-- FrizioneMin[2] = math.rad(0);
		-- FrizioneMin[3] = math.rad(0);

		-- local x, y, z = getRotation(self.PedaleFrizione);
		-- local rot = {x,y,z};
		-- local newRot = Utils.getMovedLimitedValues(rot, FrizioneMin, FrizioneMax, 3, FrizioneRotationTime, dt, FrizioneActive);
		-- setRotation(self.PedaleFrizione, unpack(newRot));
	-- end;

	-- if self.PedaleFreno ~= nil then
		-- local brakeActive = false;
		-- if acceleration > 0 then
			-- brakeActive = true;
		-- end;

		-- local brakeMax = {};
		-- brakeMax[1] = math.rad(-22);
		-- brakeMax[2] = math.rad(0);
		-- brakeMax[3] = math.rad(0);
		-- local brakeRotationTime = 500;

		-- local brakeMin = {};
		-- brakeMin[1] = math.rad(0);
		-- brakeMin[2] = math.rad(0);
		-- brakeMin[3] = math.rad(0);

		-- local x, y, z = getRotation(self.PedaleFreno);
		-- local rot = {x,y,z};
		-- local newRot = Utils.getMovedLimitedValues(rot, brakeMin, brakeMax, 3, brakeRotationTime, dt, brakeActive);
		-- setRotation(self.PedaleFreno, unpack(newRot));
	-- end;
end;


function JD7RSeries:update(dt)		


	------------------LED RISERVA----------------------
	if self.isEntered then
		if self.fuelFillLevel < 60 then
			self.riserva = self.riserva - dt;
			if self.playedSound == false then
				playSample(self.fuelwarningSoundId,1,1,0);
				self.playedSound = true;
			end;
			self.ledriservaActive = true;
		else
			self.playedSound = false;
			self.ledriservaActive = false;
		end;
		setVisibility(self.ledriserva,self.ledriservaActive);
		self:updateFuelIndicators();
	end;
	
end;
function JD7RSeries:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)
    return BaseMission.VEHICLE_LOAD_OK;
end;
function JD7RSeries:updateTick(dt)
    if self.isMotorStarted then
			setVisibility(self.olioicona, false);
		  	setVisibility(self.LedStart, true);
			
			setVisibility(self.fuelIndicatorsGroup, true);
		else
			
			setVisibility(self.olioicona, true);
			setVisibility(self.LedStart, false);
			
			setVisibility(self.fuelIndicatorsGroup, false);
		end;
	if self:getIsActive() then
		
		for k, implement in pairs(self.attachedImplements) do
				if implement.object ~= nil then
					if implement.object.isTurnedOn then
						setVisibility(self.PTOLed, true);
					else
						setVisibility(self.PTOLed, false);
					end;
				end;				
		end;
		-------------------PEDALI--------------------------------
		
			 if self.PedaleGas ~= nil then
				local percent = (self.lastSpeed*self.speedDisplayScale*3600) / self.PedaleGas.maxSpeed;
				local minRot = self.PedaleGas.rotMin;
				local maxRot = self.PedaleGas.rotMax;
				local x = minRot[1] + (maxRot[1] - minRot[1]) * percent;
				local y = minRot[2] + (maxRot[2] - minRot[2]) * percent;
				local z = minRot[3] + (maxRot[3] - minRot[3]) * percent;
				setRotation(self.PedaleGas.node, x, y, z);
	        end;
				
	self:FrizioneFrenoRotation(dt, acceleration);
	end;	

	--------------------SWITCH------------------------------



end;


function JD7RSeries:updateFuelIndicators()
	local amountOfFuelPerIndicator = self.fuelCapacity/11;
	local timesToIterate = self.fuelFillLevel/amountOfFuelPerIndicator;
	timesToIterate = math.floor(timesToIterate);
	if self.oldTimesToIterate ~= timesToIterate then
		for i=1, self.numFuelIndicators do
			setVisibility(self.fuelIndicators[i].rotNode, false);
		end;
		for i=1, timesToIterate do
			setVisibility(self.fuelIndicators[i].rotNode, true);
		end;
	end;
	self.oldTimesToIterate = timesToIterate;
end;
function JD7RSeries:draw()

	
end;


function JD7RSeries:onEnter()
        if self.isMotorStarted then
			setVisibility(self.olioicona, false);
			setVisibility(self.LedStart, true);
		else
			setVisibility(self.olioicona, true);
			setVisibility(self.LedStart, false);
		end	

	
end;
function JD7RSeries:onLeave()
	    if self.isMotorStarted then
			setVisibility(self.olioicona, false);
			setVisibility(self.LedStart, true);
	
		else
			setVisibility(self.olioicona, true);
			setVisibility(self.LedStart, false);
			
	     end	
	
end;

